var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
define(["require", "exports", "@syncfusion/ej2-vue-base", "@syncfusion/ej2-notifications", "./buttons.directive"], function (require, exports, ej2_vue_base_1, ej2_notifications_1, buttons_directive_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.properties = ['animation', 'buttons', 'content', 'cssClass', 'enablePersistence', 'enableRtl', 'extendedTimeout', 'height', 'icon', 'locale', 'newestOnTop', 'position', 'showCloseButton', 'showProgressBar', 'target', 'template', 'timeOut', 'title', 'width', 'beforeOpen', 'click', 'close', 'created', 'destroyed', 'open'];
    exports.modelProps = [];
    var ToastComponent = (function (_super) {
        __extends(ToastComponent, _super);
        function ToastComponent() {
            var _this = _super.call(this) || this;
            _this.propKeys = exports.properties;
            _this.models = exports.modelProps;
            _this.hasChildDirective = true;
            _this.hasInjectedModules = false;
            _this.tagMapper = { "e-buttonmodelprop": "e-buttonmodelprops" };
            _this.tagNameMapper = { "e-buttonmodelprop": "e-buttons" };
            _this.ej2Instances = new ej2_notifications_1.Toast({});
            _this.bindProperties();
            return _this;
        }
        ToastComponent.prototype.render = function (createElement) {
            return createElement('div', this.$slots.default);
        };
        ToastComponent.prototype.hide = function (element) {
            return this.ej2Instances.hide(element);
        };
        ToastComponent.prototype.show = function (toastObj) {
            return this.ej2Instances.show(toastObj);
        };
        ToastComponent = __decorate([
            ej2_vue_base_1.EJComponentDecorator({
                props: exports.properties
            })
        ], ToastComponent);
        return ToastComponent;
    }(ej2_vue_base_1.ComponentBase));
    exports.ToastComponent = ToastComponent;
    exports.ToastPlugin = {
        name: 'ejs-toast',
        install: function (Vue) {
            Vue.component(exports.ToastPlugin.name, ToastComponent);
            Vue.component(buttons_directive_1.ButtonModelPropsPlugin.name, buttons_directive_1.ButtonModelPropsDirective);
            Vue.component(buttons_directive_1.ButtonModelPropPlugin.name, buttons_directive_1.ButtonModelPropDirective);
        }
    };
});
